module Sluggable
  def to_slug(text)
    text.strip.downcase.gsub(/\s+/, "-").gsub(/[^\w-]/, "")
  end

  def generate_slug!(attribute)
    temp_slug = to_slug(self[attribute])

    counter = 0
    while self.class.find_by(slug: temp_slug)
      counter += 1

      # if conditional makes sure we only remove a number we added
      temp_slug.gsub!(/-\d\z/, "") if counter > 1
      temp_slug = "#{temp_slug}-#{counter}"
    end

    self.slug = temp_slug
  end

  def to_param
    slug
  end
end
